#include "config.h"
#include "app.h"
#include "app_lib.h"
#include "service.h"
#include <avr\interrupt.h>


static unsigned char key_status;
static unsigned char key_execute;

static unsigned char lock_status;

static unsigned char running_speed;
static unsigned char running_direction;

static unsigned char short_pulse;

static unsigned char auto_system;

static unsigned char no_change;



void DoorLockKey(void){
	
	if( !lock_status ){

		if( lock.sw_user_lock1 ){
			
			lock_status = LOCK;
		}
		else if (lock.sw_user_unlock1){
			
			lock_status = UNLOCK;
		}
	}
	else if(lock_status == LOCK){
		
		//if user presed long time lock key
		if(lock.sw_user_lock1_lng){
			
			LockDoor1();

			lock_status = FALSE;			
			
		}
		//if user presed short time lock key
		else if(!lock.sw_user_lock1){
			
			LockDoor1();	
			
			lock_status = FALSE;
			
		}
	}
	else if(lock_status == UNLOCK){
		
		//if user presed long time unlock key
		if(lock.sw_user_unlock1_lng){
			
			UnlockDoor1();
			ts_user_block = 0;
					
			lock_status = FALSE;

		}
		//if user presed short time lock key
		else if(!lock.sw_user_unlock1){
			
			UnlockDoor1();
			ts_user_block = 0;	
			lock_status = FALSE;
			
		}
	}
}

void DoorUserKey(void){

	ts_block_again = 90;

	if(lock_flag)
		return;

	//if no activated user key status
	if(!key_status){
			
		//if user presed open key
		if(door.sw_user_open){

			//ts_block_again = 0;
				
			//if door standing
			if( !door.state ){
				
				//if( SwitchBlock() ){
					
					if(!SwDoorUnlocked()){
						
						UnlockDoor();
						auto_system = OPEN;
					}
				
				//}	
				//Open door with max speed
				OpenDoor(255);

				no_change = TRUE;
					
			}
			//no priority
			else if(door.state == CLOSE) {

				//auto_system = FALSE;	
				
				//stop door
				StopDoor();
			}

			//increment key execute flag
			key_status = OPEN;
		}

		//if user presed close key
		else if(door.sw_user_close){
			
			//ts_block_again = 0;
				
			//if door standing
			if( !door.state){
					
				//Close door with max speed
				CloseDoor(255);

				//if(SwitchBlock()){
						
				//	auto_system = CLOSE;
				
				//}

				no_change = TRUE;
			}
			//no priority
			else if(door.state == OPEN){
				
				//auto_system = FALSE;	
				//stop door
				StopDoor();
			}
			//increment key execute flag
			key_status = CLOSE;
			
		}
	}
	//if execute type "open"
	else if(key_status == OPEN){
			
		//if user presed long time open key
		if(door.sw_user_open_lng){
			
			OpenDoor(255);		
			
			//and if open key relesed
			if(!door.sw_user_open){
						
				//stop door
				StopDoor();
				no_change = FALSE;
				key_status = FALSE;

			}
		}
		//if user presed short time open key
		else if(!door.sw_user_open){
			
			if(no_change == FALSE){
				
				StopDoor();	
			}

			if( !SwDoorUnlocked() ){
				
				//if( SwitchBlock() )
				//	auto_system = OPEN;	
				
				UnlockDoor();
				auto_system = OPEN;
				
			}
			no_change = FALSE;		
			//read new user key command
			key_status = FALSE;
		}
	}
	//if execute type "close"
	else if(key_status == CLOSE){
				
		//id user presed long time close key
		if(door.sw_user_close_lng){
			
			if(CloseDoor(255)){
				
				//if(!SwDoorLocked()){
					
					//if( SwitchBlock() )
					//	LockDoor();
				//}
				key_status = FALSE;
			
			}
					
			//and if close key is relesed
			if(!door.sw_user_close){
						
				//stop door
				StopDoor();
						
				//read new user key command
				key_status = FALSE;

			}
		}
		//if user presed short close key
		else if(!door.sw_user_close){
			
			if(no_change == FALSE){
				
				StopDoor();	
			}		 
			
			if( SwEndClose()){ 
					 
				LockDoor();
						
			}

			no_change = FALSE;

			//read new user key command
			key_status = FALSE;
		}
	}
}

void DoorUserBlockKey(void){
	
	if(lock_flag)
		return;

	//if no activated user key status
	if(!key_status){
			
		//if user presed open key
		if(door.sw_user_open){
			
			ts_block_again = 0;

			//ts_block_again = 0;
				
			//if door standing
			if( !door.state ){
				
				
					
				if(!SwDoorUnlocked()){
						
					UnlockDoor();
					auto_system = OPEN;
				}
					
				//Open door with max speed
				OpenDoor(255);

				no_change = TRUE;
					
			}
			//no priority
			else if(door.state == CLOSE) {

				//auto_system = FALSE;	
				
				//stop door
				StopDoor();
			}

			//increment key execute flag
			key_status = OPEN;
		}

		//if user presed close key
		else if(door.sw_user_close){
			
			ts_block_again = 0;
				
			//if door standing
			if( !door.state){
					
				//Close door with max speed
				CloseDoor(255);

				auto_system = CLOSE;

				//if(SwitchBlock()){
						
				//	auto_system = CLOSE;
				
				//}

				no_change = TRUE;
			}
			//no priority
			else if(door.state == OPEN){
				
				//auto_system = FALSE;	
				//stop door
				StopDoor();
			}
			//increment key execute flag
			key_status = CLOSE;
			
		}
	}
	//if execute type "open"
	else if(key_status == OPEN){
			
		//if user presed long time open key
		if(door.sw_user_open_lng){
			
			OpenDoor(255);		
			
			//and if open key relesed
			if(!door.sw_user_open){
						
				//stop door
				StopDoor();
				no_change = FALSE;
				key_status = FALSE;

			}
		}
		//if user presed short time open key
		else if(!door.sw_user_open){
			
			if(no_change == FALSE){
				
				StopDoor();	
			}

			if( !SwDoorUnlocked() ){
				
				//if( SwitchBlock() )
				//	auto_system = OPEN;	
				
				UnlockDoor();
				auto_system = OPEN;
				
			}
			no_change = FALSE;		
			//read new user key command
			key_status = FALSE;
		}
	}
	//if execute type "close"
	else if(key_status == CLOSE){
				
		//id user presed long time close key
		if(door.sw_user_close_lng){
			
			if(CloseDoor(255)){
				
				//if(!SwDoorLocked()){
					
					//if( SwitchBlock() )
					//	LockDoor();
				//}
				auto_system = CLOSE;
				key_status = FALSE;
			
			}
					
			//and if close key is relesed
			if(!door.sw_user_close){
						
				//stop door
				StopDoor();
						
				//read new user key command
				key_status = FALSE;

			}
		}
		//if user presed short close key
		else if(!door.sw_user_close){
			
			if(no_change == FALSE){
				
				StopDoor();	
			}		 
			
			if( SwEndClose()){ 
					 
				LockDoor();
						
			}

			no_change = FALSE;

			//read new user key command
			key_status = FALSE;
		}
	}
}

void AppRun(void){
	//if(SwOverCurrent28()){
	//	DoorUserKey();
	//}
	//No overflow for this timer
	if(ts_user_block > 70)
		ts_user_block = 70;

	if(auto_system == OPEN){
		
		if(!door.state && SwDoorUnlocked() ){

			OpenDoor(255);

			auto_system = FALSE;
		}

		
	}
	else if(auto_system == CLOSE){
		
		if( !door.state && !SwDoorLocked()){
			
			LockDoor();
			
			auto_system = FALSE;
		}

		
	
	}

	if( user_block_key && ts_block_again >= 90 ){
		
		if( !door.state && !SwEndClose()){
			
			CloseDoor(255);
		}
		else if( !SwDoorLocked() ){
			
			LockDoor();
		}
		if(!SwDoorLocked1() ){
			
			if(ts_user_block > 60){	
				
				LockDoor1();
			
			}
		
		}
		
	}
	
	if(ts_block_again > 90){
		
		ts_block_again=90;
	}

	if( !user_block_key ){
		DoorUserKey();
	}
	else{
		DoorUserBlockKey();
	}

	DoorLockKey();

	if( lock_flag == 1 ){
		
		if(t_lock > 1000){
			
			//Turn on hardware PWM reduction 
			OutLockPwmOff();

			//turn on motor for lock door
			OutLockOff();
							
			lock_flag = 2;

			t_lock = 0;
			
		}
		if(lock.state == LOCK){
			
			if(SwDoorLocked()){
				
				//Turn on hardware PWM reduction 
				OutLockPwmOff();

				//turn on motor for lock door
				OutLockOff();
				
				try_lock =0;
							
				lock_flag = FALSE;
			}
		}
		else if(lock.state == UNLOCK){
			
			if(SwDoorUnlocked()){
				
				//Turn on hardware PWM reduction 
				OutLockPwmOff();

				//turn on motor for lock door
				OutLockOff();

				try_lock =0;
				
				lock_flag = FALSE;
			}
		}
	
	}
	else if(lock_flag == 2){
		
		if(t_lock > 500){
			
			try_lock++;
		
			if(try_lock > 4){

				//lock.state = UNLOCK; josip
				lock_error = 1;
				OutLedErrorOn();
				lock.state = FALSE;
				//AppRestart();
			
			}
			
			lock_flag = 0;

			if(lock.state == LOCK){
				LockDoor();
			}
			else if(lock.state == UNLOCK){
				UnlockDoor();
			}
		}
		
	}

	if( lock_flag1 == 1 ){
		
		if(t_lock > 1000){
			
			//Turn on hardware PWM reduction 
			OutLockPwmOff();

			//turn on motor for lock door
			OutLockOff1();
							
			lock_flag1 = 2;

			t_lock = 0;
			
		}
		if(lock.state1 == LOCK){
			
			if(SwDoorLocked1()){
				
				//Turn on hardware PWM reduction 
				OutLockPwmOff();

				//turn on motor for lock door
				OutLockOff1();
				
				try_lock = 0;
							
				lock_flag1 = FALSE;
			}
		}
		else if(lock.state1 == UNLOCK){
			
			if(SwDoorUnlocked1()){
				
				//Turn on hardware PWM reduction 
				OutLockPwmOff();

				//turn on motor for lock door
				OutLockOff1();

				try_lock =0;
				
				lock_flag1 = FALSE;
			}
		}
	
	}
	else if(lock_flag1 == 2){
		
		if(t_lock > 500){
			
			try_lock++;
			
			if(try_lock > 4){

				lock_error1 = 1;
				OutLedErrorOn();
				lock.state1 = FALSE;
				//AppRestart();
			}
			
			
			lock_flag1 = 0;

			if(lock.state1 == LOCK){
				
				LockDoor1();
			}
			else if(lock.state1 == UNLOCK){
				
				UnlockDoor1();
			}
		}
		
	}
	
	if( !lock_flag){

		if(!SwDoorLocked() && !SwDoorUnlocked()){
			
			UnlockDoor();
		}
	}

	//Check priority of application status
	if( !app_priority ){
		
		//if current bigger then 8 A and door is unloked
		if( over_current_8A && SwDoorUnlocked() ){
				
			//if priority protection is not enabled
			if(!app_priority){
					
				//Take priority
				app_priority = 1;

				//backup door speed before stoping door
				running_speed = door.target_speed;

				//backup door direction before stoping door
				running_direction = door.state;
			}
		}
		if(over_current_4A && SwDoorUnlocked()){
			if(DoorSpeedRead() == DOOR_CRASH_SPEED){
				//if priority protection is not enabled
				if(!app_priority){
					
					//Take priority
					app_priority = 1;

					//backup door speed before stoping door
					running_speed = door.target_speed;

					//backup door direction before stoping door
					running_direction = door.state;
				}
			}
		
		}
	}
	else if(app_priority == 1){

		//Priority step 1:
		if(app_execute == 0){
				
			//if motor stoped
			if( StopDoor() ){
					
				//reset application timer for 2S waithing
				t_application = 0;

				//increment protection execute step
				app_execute++;
				
			}
			
		}
		//Priority step 2:
		else if(app_execute == 1){
				
			//if application timer biger then 2 S
			if(t_application > 2000){
					
				//increment protection execute step
				app_execute++;
						
			}
		}
		//Priority step 3:
		else if(app_execute == 2){
				
			//if last direciton was open
			if(running_direction == OPEN){
				
				//increment open try
				try_open++;
				
				//if open try uncussesfull
				if(try_open >= 5){

					if(try_close >=5){

						AppRestart();

					}
						
					//Try Close Door 
					CloseDoor(running_speed);

				}
				else{
					
					//Try open door again
					OpenDoor(running_speed);
				}
			}		
			else if(running_direction == CLOSE){
				
				try_close++;

				if(try_close >= 5){
					
					if(try_open >=5){
						
						AppRestart();
					}
					//Try open door
					OpenDoor(running_speed);
				}
				else{
					
					//Try close door again	
					CloseDoor(running_speed);
				} 
			}

			//Reset application execute flag
			app_execute = 0;
				
			//Reset prioriti
			app_priority = 0;
		}
	}

	//Check priority of application status
	if( !app_priority ){

		//execute foto funktion only if door closing
		if( SwFoto() && door.state == CLOSE ){
			
			//if priority protection is not enabled
			if( !app_priority ){
				
				//take app priority
				app_priority = 2;		

				//backup door speed before stoping door
				running_speed = door.target_speed;
		
				//Stop motor
				StopDoor(); 

 			}
		}
		//if foto is not cuted 
		else{

			//reset timer of foto sampling for new event
			t_sw_foto = 0;
		}
	}
	else if(app_priority == 2){
		
		//if "steep 1" priority execute
		if(app_execute == 0){
			
			//if motor stoped	
			if( StopDoor() ){

				//Restart application timer for execute steep
				t_application = 0;
					
				//increment app execute flag
				app_execute++;

			}			
			
		}
		//else if priority "steep 2" execute
		else if(app_execute == 1){
			
			//if timeout for 1 S waithing with door stoped	
			if(t_application > 1000){
					
				//if foto ramp actived
				if( t_sw_foto >= 400 ){
			
					//Open door with backuped speed
					OpenDoor(running_speed);
				}
				//if foto switch was relesed in 400 ms
				else{

					//Close door with backuped speed
					CloseDoor(running_speed);
				}
				
				//Reset application execute flag
				app_execute = 0;
				
				//Reset priority
				app_priority = 0;
			}
		}
		
	}
	//if foto aplication priority disabled
	else{

		//reset timer for foto sampling for new event
		t_sw_foto = 0;
	}

	if(!app_priority){
	
		if(  ts_auto_close >= 100 ){
			
			if( (!SwFoto()) && (!SwEndClose()) ){
				
				CloseDoor(255);
			}

			ts_auto_close = 0;
		}
	}

	//Run Application Service
	Service();

}
