#include "avr\interrupt.h"
#include "haus_control.h"
#include "board_drv.h"

static unsigned char ad_mux;

void SecUpdate(void){
	ts_auto_wathering++;
	ts_auto_close++;
	ts_direction_timeout++;
	ts_block_again++;
	ts_user_block++;
}


ISR(TIMER3_OVF_vect){	
	ResetTimer();

	t_application++;
	t_ad_refresh++;
	t_sw_fontana++;
	t_sw_saht++;
	t_sw_wathering++;
	t_sw_raining++;
	t_sw_garden_light++;
	t_garden_light++;
	t_sw_outside_light++;
	t_outside_light++;
	t_outside_light_exe++;
	t_door_target_speed++;
	t_pick_counter_events++;
	t_sw_foto++;
	t_direction_ramp++;
	t_beep++;
	t_sw_user_close++;
	t_sw_user_open++;
	t_when_sw_open++;
	t_when_sw_close++;
	t_over_current_4A++;
	t_over_current_8A++;
	t_sec_update++;
	t_sw_user_lock1++;
	t_sw_user_unlock1++;
	t_when_sw_lock1++;
	t_when_sw_unlock1++;
	t_lock++;
	t_user_block_key++;
	t_led_run++;
	
	
	if(t_sec_update >= 1000){
		
		SecUpdate();

		t_sec_update = 0; 

	}
}


ISR(ADC_vect){

	if(ad_mux == 0)

		ReadAdValue(ad_high_temp);

	if(ad_mux == 1)

		ReadAdValue( ad_light ); 

	else if(ad_mux == 2)

		ReadAdValue( ad_foto_temp );

	else if(ad_mux == 3)
		
		ReadAdValue(ad_low_voltage);

}

void AdConvert(void){
	
	//reset timer for ad convertion ramp
	t_ad_refresh = 0;
	
	ResetAdMux();
	
	if(ad_mux == 0)

		ADmuxGardenLight();

	else if(ad_mux == 1)

		ADmuxFotoTemp();
	
	else if(ad_mux == 2)

		ADmuxLowVoltage();
	
	else if (ad_mux == 3)
		
		ADmuxHighTemp();

	
	if(++ad_mux == 4)

		ad_mux = 0;
	
	StartAdConvert();
}
